import express from 'express';
import controller from '../../controllers/app/currency';

const router = express.Router();


// #region /api/app/currencies/getDefaultCurrency apidoc
/**
 * @api {post} /api/app/currencies/getDefaultCurrency Get DefaultCurrency
 * @apiVersion 1.0.0
 * @apiName Get DefaultCurrency
 * @apiDescription Get DefaultCurrency
 * @apiGroup Currency - App
 * @apiSuccess (200) {JSON} Result status, message, recordList, totalRecords.
 * @apiSuccessExample {json} Success-200-Response:
 *     HTTP/1.1 200 OK
 *     {
 *         "status": 200,
 *         "isDisplayMessage": true,
 *         "message": "Get  Successfully",
 *         "recordList": [
 *             {
 *             },....
 *         ],
 *         "totalRecords": 11,
 *         "token": ""
 *     }
 * @apiError (500) {JSON} Result message, apiName, apiType, fileName, functionName, lineNumber, typeName, stack.
 * @apiErrorExample {json} Error-500-Response:
 *     HTTP/1.1 500 ERROR
 *     {
 *          status: <error status code>,
 *          isDisplayMessage: <true/false>, // if the value is true then display message on screen
 *          message: <error message>,
 *          error: {
 *              apiName: <api name>,
 *              apiType: <api type>,
 *              fileName: <file name>,
 *              functionName: <function name>,
 *              lineNumber: <line number>,
 *              typeName: <type name>,
 *              stack: <stack>
 *          },
 *          value: <value if any>
 *     }
 */
// #endregion
router.post('/getDefaultCurrency',controller.getDefaultCurrency);

export = router;